﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Storage;
using System;
using System.Threading.Tasks;

namespace MonitoringAnalysis.Dal.Abstract
{
    /// <inheritdoc />
    /// <summary>
    /// Unit of work interface
    /// Maintains a list of objects affected by a business transaction and coordinates the writing out of changes and the resolution of concurrency problems.
    /// </summary>
    /// <seealso cref="T:System.IDisposable" />
    /// <autogeneratedoc />
    public interface IUnitOfWork : IDisposable
    {
        /// <summary>
        /// Gets the database context. DatabaseContext is part of EF and itself is implementation of UoW (and repo) patterns
        /// </summary>
        /// <value>
        /// The database context.
        /// </value>
        /// <remarks> 
        /// If true  UoW was implemented this wouldn't be here, but we are exposing this for simplicity sake. 
        /// For example so that repository  could use benefits of DbContext and DbSet <see cref="DbSet"/>. One of those benefits are Find and FindAsnyc methods
        /// </remarks>
        DbContext DatabaseContext { get; }

        /// <summary>
        /// Transaction Warehouse
        /// </summary>
        IDbContextTransaction Transaction { get; }

        Guid UserContext { get; }

        /// <summary>
        /// Generate a transaction
        /// </summary>
        /// <returns></returns>
        IDbContextTransaction BeginTransaction();

        /// <summary>
        /// Enter context user
        /// </summary>
        /// <returns></returns>
        bool SetUser(Guid userContext);

        /// <summary>
        /// Rollback transactions
        /// </summary>
        void RollBack();

        /// <summary>
        /// Commits the changes to database
        /// </summary>
        /// <returns></returns>
        int Commit();

        /// <summary>
        /// Asynchronously commits changes to database.
        /// </summary>
        /// <returns></returns>
        Task CommitAsync();

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        int EndTransaction();
    }
}
